﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinEditors;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        UltraDataSource _uds1;
        UltraDataSource _uds2;

        public Form1()
        {
            InitializeComponent();

            initGrids();
            bindGrids();
        }

        private void initGrids()
        {
            _uds1 = new UltraDataSource();
            _uds1.ResetBand();
            _uds1.Band.Columns.Add("COL1", typeof(String));
            _uds1.Band.Columns.Add("COL2", typeof(String));

            _uds2 = new UltraDataSource();
            _uds2.ResetBand();
            _uds2.Band.Columns.Add("COL1", typeof(String));
            _uds2.Band.Columns.Add("COL2", typeof(String));

            ultraGrid1.DataSource = _uds1;
            ultraGrid2.DataSource = _uds2;
        }

        private void bindGrids()
        {
            UltraDataRow __addedRow = null;

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Monday", false);
            __addedRow.SetCellValue("COL2", "10", false);

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Tuesday", false);
            __addedRow.SetCellValue("COL2", "15", false);

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Wednesday", false);
            __addedRow.SetCellValue("COL2", "2", false);

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Thursday", false);
            __addedRow.SetCellValue("COL2", "25", false);

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Friday", false);
            __addedRow.SetCellValue("COL2", "24", false);

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Saturday", false);
            __addedRow.SetCellValue("COL2", "16", false);

            __addedRow = _uds1.Rows.Add();
            __addedRow.SetCellValue("COL1", "Sunday", false);
            __addedRow.SetCellValue("COL2", "3", false);

            // 2

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Monday", false);
            __addedRow.SetCellValue("COL2", "10", false);

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Tuesday", false);
            __addedRow.SetCellValue("COL2", "15", false);

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Wednesday", false);
            __addedRow.SetCellValue("COL2", "2", false);

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Thursday", false);
            __addedRow.SetCellValue("COL2", "25", false);

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Friday", false);
            __addedRow.SetCellValue("COL2", "24", false);

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Saturday", false);
            __addedRow.SetCellValue("COL2", "16", false);

            __addedRow = _uds2.Rows.Add();
            __addedRow.SetCellValue("COL1", "Sunday", false);
            __addedRow.SetCellValue("COL2", "3", false);
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (!e.ReInitialize)
            {
                UltraControlContainerEditor __container = new UltraControlContainerEditor();
                ResultMasterControl __editingResultMasterControl = new ResultMasterControl();
                ResultMasterControl __renderingResultMasterControl = new ResultMasterControl();

                __container.EditingControl = __editingResultMasterControl;
                __container.EditingControlPropertyName = "Result";
                __container.RenderingControl = __renderingResultMasterControl;
                __container.RenderingControlPropertyName = "Result";
                __container.ApplyOwnerAppearanceToEditingControl = true;
                __container.ApplyOwnerAppearanceToRenderingControl = true;
                __container.EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick;

                e.Row.Cells["COL2"].EditorComponent = __container;
            }
        }

        private void ultraGrid2_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (!e.ReInitialize)
            {
                UltraControlContainerEditor __container = new UltraControlContainerEditor();
                ResultMasterControl __editingResultMasterControl = new ResultMasterControl();
                ResultMasterControl __renderingResultMasterControl = new ResultMasterControl();

                __container.EditingControl = __editingResultMasterControl;
                __container.EditingControlPropertyName = "Result";
                __container.RenderingControl = __renderingResultMasterControl;
                __container.RenderingControlPropertyName = "Result";
                __container.ApplyOwnerAppearanceToEditingControl = true;
                __container.ApplyOwnerAppearanceToRenderingControl = true;
                __container.EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick;

                e.Row.Cells["COL2"].EditorComponent = __container;
            }
        }

        private void ultraGrid1_BeforeExitEditMode(object sender, Infragistics.Win.UltraWinGrid.BeforeExitEditModeEventArgs e)
        {
            if (ultraGrid1.ActiveCell != null)
            {
                if (ultraGrid1.ActiveCell.Column.Key.Equals("COL2"))
                {
                    e.Cancel = true;
                }
            }
        }
    }
}
